libstdc++: Complex Numbers

libstdc++

Complex Numbers
Numerics
Collaboration diagram for Complex Numbers:

## Classes
class | std::complex< _Tp >
class | std::complex< double >
class | std::complex< float >
class | std::complex< long double >

## Functions
template<typename _Tp>
_Tp | std::__complex_abs (const complex< _Tp > &__z)
template<typename _Tp>
_Tp | std::__complex_arg (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_cos (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_cosh (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_exp (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_log (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_pow (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp>
complex< _Tp > | std::__complex_pow_unsigned (complex< _Tp > __x, unsigned __n)
template<typename _Tp>
complex< _Tp > | std::__complex_sin (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_sinh (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_sqrt (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_tan (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::__complex_tanh (const complex< _Tp > &__z)
template<typename _Tp>
_Tp | std::abs (const complex< _Tp > &)
template<typename _Tp>
_Tp | std::arg (const complex< _Tp > &)
template<typename _Tp>
constexpr complex< _Tp > | std::conj (const complex< _Tp > &)
template<typename _Tp>
std::complex< typename __gnu_cxx::__promote< _Tp >::__type > | std::tr1::conj (_Tp __x)
template<typename _Tp>
std::complex< _Tp > | std::tr1::conj (const std::complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::cos (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::cosh (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::exp (const complex< _Tp > &)
template<typename _Tp>
std::complex< _Tp > | std::tr1::fabs (const std::complex< _Tp > &__z)
template<typename _Tp>
constexpr _Tp | std::imag (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::log (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::log10 (const complex< _Tp > &)
template<typename _Tp>
_Tp constexpr | std::norm (const complex< _Tp > &)
template<typename _Tp>
constexpr complex< _Tp > & | std::complex< _Tp >::operator*= (const _Tp &__t)
template<typename _Up>
constexpr complex< _Tp > & | std::complex< _Tp >::operator*= (const complex< _Up > &__z)
template<typename _Tp>
constexpr complex< _Tp > | std::operator+ (const complex< _Tp > &__x)
template<typename _Up>
constexpr complex< _Tp > & | std::complex< _Tp >::operator+= (const complex< _Up > &__z)
template<typename _Tp>
constexpr complex< _Tp > | std::operator- (const complex< _Tp > &__x)
template<typename _Up>
constexpr complex< _Tp > & | std::complex< _Tp >::operator-= (const complex< _Up > &__z)
template<typename _Tp>
constexpr complex< _Tp > & | std::complex< _Tp >::operator/= (const _Tp &__t)
template<typename _Up>
constexpr complex< _Tp > & | std::complex< _Tp >::operator/= (const complex< _Up > &__z)
template<typename _Tp, typename _CharT, class _Traits>
basic_ostream< _CharT, _Traits > & | std::operator<< (basic_ostream< _CharT, _Traits > &__os, const complex< _Tp > &__x)
template ostream & | std::operator<< (ostream &, const complex< double > &)
template ostream & | std::operator<< (ostream &, const complex< float > &)
template ostream & | std::operator<< (ostream &, const complex< long double > &)
template wostream & | std::operator<< (wostream &, const complex< double > &)
template wostream & | std::operator<< (wostream &, const complex< float > &)
template wostream & | std::operator<< (wostream &, const complex< long double > &)
template<typename _Tp>
constexpr complex< _Tp > & | std::complex< _Tp >::operator= (const _Tp &__t)
template<typename _Up>
constexpr complex< _Tp > & | std::complex< _Tp >::operator= (const complex< _Up > &__z)
template<typename _Tp, typename _CharT, class _Traits>
basic_istream< _CharT, _Traits > & | std::operator>> (basic_istream< _CharT, _Traits > &__is, complex< _Tp > &__x)
template istream & | std::operator>> (istream &, complex< double > &)
template istream & | std::operator>> (istream &, complex< float > &)
template istream & | std::operator>> (istream &, complex< long double > &)
template wistream & | std::operator>> (wistream &, complex< double > &)
template wistream & | std::operator>> (wistream &, complex< float > &)
template wistream & | std::operator>> (wistream &, complex< long double > &)
template<typename _Tp>
complex< _Tp > | std::polar (const _Tp &, const _Tp &=_Tp(0))
template<typename _Tp, typename _Up>
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::polar (const _Tp &__rho, const _Up &__theta)
template<typename _Tp>
complex< _Tp > | std::pow (const _Tp &, const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::pow (const complex< _Tp > &, const _Tp &)
template<typename _Tp>
complex< _Tp > | std::pow (const complex< _Tp > &, const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::pow (const complex< _Tp > &, int)
template<typename _Tp>
std::complex< _Tp > | std::tr1::pow (const _Tp &__x, const std::complex< _Tp > &__y)
template<typename _Tp, typename _Up>
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::pow (const _Tp &__x, const std::complex< _Up > &__y)
template<typename _Tp>
std::complex< _Tp > | std::tr1::pow (const std::complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp, typename _Up>
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::pow (const std::complex< _Tp > &__x, const _Up &__y)
template<typename _Tp>
std::complex< _Tp > | std::tr1::pow (const std::complex< _Tp > &__x, const std::complex< _Tp > &__y)
template<typename _Tp, typename _Up>
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::pow (const std::complex< _Tp > &__x, const std::complex< _Up > &__y)
template<typename _Tp>
constexpr _Tp | std::real (const complex< _Tp > &__z)
template<typename _Tp>
complex< _Tp > | std::sin (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::sinh (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::sqrt (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::tan (const complex< _Tp > &)
template<typename _Tp>
complex< _Tp > | std::tanh (const complex< _Tp > &)
template<typename _Tp>
constexpr complex< _Tp > | std::operator+ (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator+ (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator+ (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator- (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator- (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator- (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator* (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator* (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator* (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator/ (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator/ (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp>
constexpr complex< _Tp > | std::operator/ (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr bool | std::operator== (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp>
constexpr bool | std::operator== (const complex< _Tp > &__x, const _Tp &__y)

## Detailed Description

Classes and functions for complex numbers.

## Macro Definition Documentation

## ◆ _GLIBCXX26_DECLARE_COMPLEX_TUPLE_HELPER_ACCESSOR

#define _GLIBCXX26_DECLARE_COMPLEX_TUPLE_HELPER_ACCESSOR

Definition at line 1430 of file complex.

## Function Documentation

## ◆ __complex_abs()

template<typename _Tp>

_Tp std::__complex_abs | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 939 of file complex.

## ◆ __complex_arg()

template<typename _Tp>

_Tp std::__complex_arg | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 975 of file complex.

## ◆ __complex_cos()

template<typename _Tp>

complex< _Tp > std::__complex_cos | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1055 of file complex.

## ◆ __complex_cosh()

template<typename _Tp>

complex< _Tp > std::__complex_cosh | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1085 of file complex.

## ◆ __complex_exp()

template<typename _Tp>

complex< _Tp > std::__complex_exp | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1115 of file complex.

## ◆ __complex_log()

template<typename _Tp>

complex< _Tp > std::__complex_log | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1142 of file complex.

## ◆ __complex_pow()

template<typename _Tp>

complex< _Tp > std::__complex_pow | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inline

Definition at line 1382 of file complex.

## ◆ __complex_pow_unsigned()

template<typename _Tp>

complex< _Tp > std::__complex_pow_unsigned | ( | complex< _Tp > | __x,
|  | unsigned | __n )

Definition at line 1335 of file complex.

## ◆ __complex_sin()

template<typename _Tp>

complex< _Tp > std::__complex_sin | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1173 of file complex.

## ◆ __complex_sinh()

template<typename _Tp>

complex< _Tp > std::__complex_sinh | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1203 of file complex.

## ◆ __complex_sqrt()

template<typename _Tp>

complex< _Tp > std::__complex_sqrt | ( | const complex< _Tp > & | __z | ) |

Definition at line 1234 of file complex.

## ◆ __complex_tan()

template<typename _Tp>

complex< _Tp > std::__complex_tan | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1278 of file complex.

## ◆ __complex_tanh()

template<typename _Tp>

complex< _Tp > std::__complex_tanh | ( | const complex< _Tp > & | __z | ) |
| inline

Definition at line 1306 of file complex.

## ◆ abs()

template<typename _Tp>

_Tp std::abs | ( | const complex< _Tp > & | __z | ) |
| inline

Return magnitude of z.

Definition at line 968 of file complex.

Referenced by fabs(), std::tr1::fabs(), frexp(), std::binomial_distribution< _IntType >::operator()(), and std::poisson_distribution< _IntType >::operator()().

## ◆ arg()

template<typename _Tp>

_Tp std::arg | ( | const complex< _Tp > & | __z | ) |
| inline

Return phase angle of z.

Definition at line 995 of file complex.

## ◆ conj() [1/3]

template<typename _Tp>

complex< _Tp > std::conj | ( | const complex< _Tp > & | __z | ) |
| inlineconstexpr

Return complex conjugate of z.

Definition at line 1047 of file complex.

## ◆ conj() [2/3]

template<typename _Tp>

std::complex< typename __gnu_cxx::__promote< _Tp >::__type > std::tr1::conj | ( | _Tp | __x | ) |
| inline

Definition at line 386 of file tr1/complex.

## ◆ conj() [3/3]

template<typename _Tp>

std::complex< _Tp > std::tr1::conj | ( | const std::complex< _Tp > & | __z | ) |
| inline

Definition at line 381 of file tr1/complex.

## ◆ cos()

template<typename _Tp>

complex< _Tp > std::cos | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex cosine of z.

Definition at line 1079 of file complex.

Referenced by polar().

## ◆ cosh()

template<typename _Tp>

complex< _Tp > std::cosh | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex hyperbolic cosine of z.

Definition at line 1109 of file complex.

## ◆ exp()

template<typename _Tp>

complex< _Tp > std::exp | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex base e exponential of z.

Definition at line 1135 of file complex.

Referenced by pow().

## ◆ fabs()

template<typename _Tp>

std::complex< _Tp > std::tr1::fabs | ( | const std::complex< _Tp > & | __z | ) |
| inline

fabs(__z) [8.1.8].

Definition at line 313 of file tr1/complex.

References std::abs().

## ◆ imag()

template<typename _Tp>

_Tp std::imag | ( | const complex< _Tp > & | __z | ) |
| constexpr

Definition at line 616 of file complex.

## ◆ log()

template<typename _Tp>

complex< _Tp > std::log | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex natural logarithm of z.

Definition at line 1162 of file complex.

Referenced by log10(), std::binomial_distribution< _IntType >::operator()(), std::gamma_distribution< _RealType >::operator()(), std::normal_distribution< _RealType >::operator()(), std::poisson_distribution< _IntType >::operator()(), operator<<(), operator<<(), operator<<(), operator<<(), pow(), and pow().

## ◆ log10()

template<typename _Tp>

complex< _Tp > std::log10 | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex base 10 logarithm of z.

Definition at line 1167 of file complex.

References log().

## ◆ norm()

template<typename _Tp>

_Tp constexpr std::norm | ( | const complex< _Tp > & | __z | ) |
| inlineconstexpr

Return z magnitude squared.

Definition at line 1031 of file complex.

## ◆ operator*() [1/3]

template<typename _Tp>

complex< _Tp > std::operator* | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x times y.

Definition at line 452 of file complex.

## ◆ operator*() [2/3]

template<typename _Tp>

complex< _Tp > std::operator* | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y )
| inlineconstexpr

Return new complex value x times y.

Definition at line 443 of file complex.

## ◆ operator*() [3/3]

template<typename _Tp>

complex< _Tp > std::operator* | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x times y.

Definition at line 434 of file complex.

## ◆ operator*=() [1/2]

template<typename _Tp>
template<typename _Tp>

complex< _Tp > & std::complex< _Tp >::operator*= | ( | const _Tp & | __t | ) |
| constexpr

Definition at line 293 of file complex.

## ◆ operator*=() [2/2]

template<typename _Tp>
template<typename _Up>

complex< _Tp > & std::complex< _Tp >::operator*= | ( | const complex< _Up > & | __z | ) |
| constexpr

Definition at line 347 of file complex.

## ◆ operator+() [1/4]

template<typename _Tp>

complex< _Tp > std::operator+ | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x plus y.

Definition at line 392 of file complex.

## ◆ operator+() [2/4]

template<typename _Tp>

complex< _Tp > std::operator+ | ( | const complex< _Tp > & | __x | ) |
| inlineconstexpr

Return x.

Definition at line 493 of file complex.

## ◆ operator+() [3/4]

template<typename _Tp>

complex< _Tp > std::operator+ | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y )
| inlineconstexpr

Return new complex value x plus y.

Definition at line 383 of file complex.

## ◆ operator+() [4/4]

template<typename _Tp>

complex< _Tp > std::operator+ | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x plus y.

Definition at line 374 of file complex.

## ◆ operator+=()

template<typename _Tp>
template<typename _Up>

complex< _Tp > & std::complex< _Tp >::operator+= | ( | const complex< _Up > & | __z | ) |
| constexpr

Definition at line 324 of file complex.

## ◆ operator-() [1/4]

template<typename _Tp>

complex< _Tp > std::operator- | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x minus y.

Definition at line 422 of file complex.

## ◆ operator-() [2/4]

template<typename _Tp>

complex< _Tp > std::operator- | ( | const complex< _Tp > & | __x | ) |
| inlineconstexpr

Return complex negation of x.

Definition at line 499 of file complex.

## ◆ operator-() [3/4]

template<typename _Tp>

complex< _Tp > std::operator- | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y )
| inlineconstexpr

Return new complex value x minus y.

Definition at line 413 of file complex.

## ◆ operator-() [4/4]

template<typename _Tp>

complex< _Tp > std::operator- | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x minus y.

Definition at line 404 of file complex.

## ◆ operator-=()

template<typename _Tp>
template<typename _Up>

complex< _Tp > & std::complex< _Tp >::operator-= | ( | const complex< _Up > & | __z | ) |
| constexpr

Definition at line 335 of file complex.

## ◆ operator/() [1/3]

template<typename _Tp>

complex< _Tp > std::operator/ | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x divided by y.

Definition at line 482 of file complex.

## ◆ operator/() [2/3]

template<typename _Tp>

complex< _Tp > std::operator/ | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y )
| inlineconstexpr

Return new complex value x divided by y.

Definition at line 473 of file complex.

## ◆ operator/() [3/3]

template<typename _Tp>

complex< _Tp > std::operator/ | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return new complex value x divided by y.

Definition at line 464 of file complex.

## ◆ operator/=() [1/2]

template<typename _Tp>
template<typename _Tp>

complex< _Tp > & std::complex< _Tp >::operator/= | ( | const _Tp & | __t | ) |
| constexpr

Definition at line 303 of file complex.

## ◆ operator/=() [2/2]

template<typename _Tp>
template<typename _Up>

complex< _Tp > & std::complex< _Tp >::operator/= | ( | const complex< _Up > & | __z | ) |
| constexpr

Definition at line 360 of file complex.

## ◆ operator<<()

template<typename _Tp, typename _CharT, class _Traits>

basic_ostream< _CharT, _Traits > & std::operator<< | ( | basic_ostream< _CharT, _Traits > & | __os,
|  | const complex< _Tp > & | __x )

Insertion operator for complex values.

Definition at line 543 of file complex.

References std::ios_base::failbit, std::basic_istream< _CharT, _Traits >::putback(), std::basic_ios< _CharT, _Traits >::setstate(), and std::basic_ios< _CharT, _Traits >::widen().

## ◆ operator=() [1/2]

template<typename _Tp>
template<typename _Tp>

complex< _Tp > & std::complex< _Tp >::operator= | ( | const _Tp & | __t | ) |
| constexpr

Definition at line 283 of file complex.

## ◆ operator=() [2/2]

template<typename _Tp>
template<typename _Up>

complex< _Tp > & std::complex< _Tp >::operator= | ( | const complex< _Up > & | __z | ) |
| constexpr

Definition at line 313 of file complex.

## ◆ operator==() [1/2]

template<typename _Tp>

bool std::operator== | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y )
| inlineconstexpr

Return true if x is equal to y.

Definition at line 511 of file complex.

## ◆ operator==() [2/2]

template<typename _Tp>

bool std::operator== | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inlineconstexpr

Return true if x is equal to y.

Definition at line 506 of file complex.

## ◆ operator>>()

template<typename _Tp, typename _CharT, class _Traits>

basic_istream< _CharT, _Traits > & std::operator>> | ( | basic_istream< _CharT, _Traits > & | __is,
|  | complex< _Tp > & | __x )

Extraction operator for complex values.

Definition at line 543 of file complex.

## ◆ polar() [1/2]

template<typename _Tp>

complex< _Tp > std::polar | ( | const _Tp & | __rho,
|  | const _Tp & | __theta = _Tp(0) )
| inline

Return complex with magnitude rho and angle theta.

Definition at line 1039 of file complex.

References cos(), and sin().

Referenced by pow(), and pow().

## ◆ polar() [2/2]

template<typename _Tp, typename _Up>

std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > std::tr1::polar | ( | const _Tp & | __rho,
|  | const _Up & | __theta )
| inline

Definition at line 395 of file tr1/complex.

## ◆ pow() [1/10]

template<typename _Tp>

complex< _Tp > std::pow | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y )
| inline

Return x to the y'th power.

Definition at line 1412 of file complex.

References log(), polar(), and pow().

## ◆ pow() [2/10]

template<typename _Tp>

complex< _Tp > std::pow | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y )

Return x to the y'th power.

Definition at line 1367 of file complex.

References exp(), log(), polar(), and pow().

## ◆ pow() [3/10]

template<typename _Tp>

complex< _Tp > std::pow | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y )
| inline

Return x to the y'th power.

Definition at line 1406 of file complex.

## ◆ pow() [4/10]

template<typename _Tp>

complex< _Tp > std::pow | ( | const complex< _Tp > & | __z,
|  | int | __n )
| inline

Return x to the y'th power.

Definition at line 1357 of file complex.

Referenced by std::gamma_distribution< _RealType >::operator()(), operator<<(), pow(), pow(), and std::tr1::pow().

## ◆ pow() [5/10]

template<typename _Tp>

std::complex< _Tp > std::tr1::pow | ( | const _Tp & | __x,
|  | const std::complex< _Tp > & | __y )
| inline

Definition at line 410 of file tr1/complex.

## ◆ pow() [6/10]

template<typename _Tp, typename _Up>

std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > std::tr1::pow | ( | const _Tp & | __x,
|  | const std::complex< _Up > & | __y )
| inline

Definition at line 362 of file tr1/complex.

## ◆ pow() [7/10]

template<typename _Tp>

std::complex< _Tp > std::tr1::pow | ( | const std::complex< _Tp > & | __x,
|  | const _Tp & | __y )
| inline

Definition at line 405 of file tr1/complex.

## ◆ pow() [8/10]

template<typename _Tp, typename _Up>

std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > std::tr1::pow | ( | const std::complex< _Tp > & | __x,
|  | const _Up & | __y )
| inline

Additional overloads [8.1.9].

Definition at line 354 of file tr1/complex.

References std::pow().

## ◆ pow() [9/10]

template<typename _Tp>

std::complex< _Tp > std::tr1::pow | ( | const std::complex< _Tp > & | __x,
|  | const std::complex< _Tp > & | __y )
| inline

Definition at line 415 of file tr1/complex.

## ◆ pow() [10/10]

template<typename _Tp, typename _Up>

std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > std::tr1::pow | ( | const std::complex< _Tp > & | __x,
|  | const std::complex< _Up > & | __y )
| inline

Definition at line 370 of file tr1/complex.

## ◆ real()

template<typename _Tp>

_Tp std::real | ( | const complex< _Tp > & | __z | ) |
| constexpr

Definition at line 611 of file complex.

## ◆ sin()

template<typename _Tp>

complex< _Tp > std::sin | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex sine of z.

Definition at line 1197 of file complex.

Referenced by polar().

## ◆ sinh()

template<typename _Tp>

complex< _Tp > std::sinh | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex hyperbolic sine of z.

Definition at line 1227 of file complex.

## ◆ sqrt()

template<typename _Tp>

complex< _Tp > std::sqrt | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex square root of z.

Definition at line 1271 of file complex.

Referenced by std::normal_distribution< _RealType >::operator()(), and std::student_t_distribution< _RealType >::operator()().

## ◆ tan()

template<typename _Tp>

complex< _Tp > std::tan | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex tangent of z.

Definition at line 1298 of file complex.

Referenced by operator<<().

## ◆ tanh()

template<typename _Tp>

complex< _Tp > std::tanh | ( | const complex< _Tp > & | __z | ) |
| inline

Return complex hyperbolic tangent of z.

Definition at line 1326 of file complex.